/*
2887      по каким дням недели осуществлять подмену воды            Байт                
                                                             7   6   5   4   3   2   1   0 
                                                             0  Пн. Вт. Ср. Чт. Пт. Сб. Вс.    
время включения слива                                                             
2888  2889  понедельник час мин
2890  2891  вторник час мин                                                           
2892  2893  среда час мин
2894  2895  четверг час мин
2896  2897  пятница час мин                                                           
2898  2899  суббота час мин
2900  2901  воскресения час мин

длительность слива
2902  понедельник  
2903  вторник
2904  среда
2905  четверг
2906  пятница
2907  суббота
2908  воскресения

void setAutoChangeWater(byte DN, byte Chas, byte Min, int Dlit, bool OK)
{
  byte temp, DN_Old, M;
  lcd.clear();
  lcd.setCursor(0, 0);lcd.print("AutoChangeWater");
  lcd.setCursor(2, 1);lcd.print("PLEASE WAIT");
  DN_Old = EEPROM.read(2887);

//Определяем маску для стирания дня недели
  if(DN == 1 && !OK) M = 254; else //Определяем для каналов маску 11111110
  if(DN == 2 && !OK) M = 253; else //Определяем для каналов маску 11111101
  if(DN == 3 && !OK) M = 251; else //Определяем для каналов маску 11111011
  if(DN == 4 && !OK) M = 247; else //Определяем для каналов маску 11110111
  if(DN == 5 && !OK) M = 239; else //Определяем для каналов маску 11101111
  if(DN == 6 && !OK) M = 223; else //Определяем для каналов маску 11011111
  if(DN == 7 && !OK) M = 191;      //Определяем для каналов маску 10111111

//Определяем маску для установки дня недели  
  if(DN == 1 && OK) M = 1; else  //Определяем для каналов маску 00000001
  if(DN == 2 && OK) M = 2; else  //Определяем для каналов маску 00000010
  if(DN == 3 && OK) M = 4; else  //Определяем для каналов маску 00000100
  if(DN == 4 && OK) M = 8; else  //Определяем для каналов маску 00001000
  if(DN == 5 && OK) M = 16; else //Определяем для каналов маску 00010000
  if(DN == 6 && OK) M = 32; else //Определяем для каналов маску 00100000
  if(DN == 7 && OK) M = 64;      //Определяем для каналов маску 01000000

  if(OK)
  {
    if(!(DN_Old & M)) DN_Old += M; //Если день еще не установлен то добавляем
  } 
  else
    DN_Old = DN_Old & M; //Удоляем день недели
  
  EEPROM.write(2887, DN_Old);  //Записываем дни недели по которым осуществлять слив после изменения

  if(OK)
  {
    EEPROM.write(2886 + (DN*2), Chas);  //Записываем часы когда начинать слив
    EEPROM.write(2887 + (DN*2), Min);   //Записываем минуты  когда начинать слив  
    EEPROM.write(2901 + DN, Dlit);      //Записываем время в течении которого осуществлять слив  
    setTimeTad(10, Chas, Min, Chas, Min+1);
  }  
  lcd.clear();
  return;
}


//==================================================================================================
void AutoChangeWater(byte Chas, byte Min)
{
  byte Dn =  EEPROM.read(2887);
  byte M;
  int T =0;

  if(WDAY == 1) M = 1;  //Определяем для каналов маску 00000001
  if(WDAY == 2) M = 2;  //Определяем для каналов маску 00000010
  if(WDAY == 3) M = 4;  //Определяем для каналов маску 00000100
  if(WDAY == 4) M = 8;  //Определяем для каналов маску 00001000
  if(WDAY == 5) M = 16; //Определяем для каналов маску 00010000
  if(WDAY == 6) M = 32; //Определяем для каналов маску 00100000
  if(WDAY == 7) M = 64;      //Определяем для каналов маску 01000000
  
  if(Dn & M)
  {
    if(((M == 1) && (EEPROM.read(2888) == Chas) && (EEPROM.read(2889) == Min))) 
    { 
      SLIV = true; 
      SlivMin = 0; 
      SlivDlit = EEPROM.read(2902); 
    } //Если понедельник
      
    if(((M == 2) && (EEPROM.read(2890) == Chas) && (EEPROM.read(2891) == Min))) 
    { 
      SLIV = true; 
      SlivMin = 0; 
      SlivDlit = EEPROM.read(2903); 
    } //Если вторник
      
    if(((M == 4) && (EEPROM.read(2892) == Chas) && (EEPROM.read(2893) == Min))) 
    { 
      SLIV = true;
      SlivMin = 0; 
      SlivDlit = EEPROM.read(2904); 
    } //Если среда
      
    if(((M == 8)  && (EEPROM.read(2894) == Chas) && (EEPROM.read(2895) == Min))) 
    { 
      SLIV = true; 
      SlivMin = 0; 
      SlivDlit = EEPROM.read(2905); 
    } //Если четверг
      
    if(((M == 16)  && (EEPROM.read(2896) == Chas) && (EEPROM.read(2897) == Min))) 
    {
      SLIV = true; 
      SlivMin = 0; 
      SlivDlit = EEPROM.read(2906); 
    } //Если пятница
      
    if(((M == 32)  && (EEPROM.read(2898) == Chas) && (EEPROM.read(2899) == Min))) 
    { 
      SLIV = true; 
      SlivMin = 0; 
      SlivDlit = EEPROM.read(2907); 
    } //Если суббота
      
    if(((M == 64)  && (EEPROM.read(2900) == Chas) && (EEPROM.read(2901) == Min))) 
    { 
      SLIV = true; 
      SlivMin = 0; 
      SlivDlit = EEPROM.read(2908); 
    } //Если воскресение

    if(SLIV) 
    {
      SlivStart();

      T = (Chas*60) +  Min;
      T += SlivDlit; 
      lcd.setCursor(0, 1); //Очищаем вторую строку
      lcd.print(String("CLIV  OFF"));  //если бит меняется с 1 на 0 то выклучение
      lcd.setCursor(11, 1); //Очищаем часть экрана где выводится время след события
      lcd.print(String(print2digits(int(T/60))) + String(':') + String(print2digits(T - (int(T/60)*60)))); //Выводим время следующего события
    }  
  }  
  return;
}
*/
