//============================================================================================================

void SendUDPMessage(String StrBuffer)
{
    char temp[512];
    int a;
    if(HellowProg)
    {
      for(a=0;a<StrBuffer.length();a++) temp[a] = StrBuffer.charAt(a);
      temp[a] = '\x0';
      Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
      Udp.write(temp);
      Udp.endPacket();
    }  
    return;
}

//============================================================================================================

void ReadEthernetUDP()
{
  String currStr;
  char buf[5];   //Временные буферы
  byte Chas; 
  byte Min; 
  
  // если есть доступные данные, считайте пакет
  int packetSize = Udp.parsePacket();
  if (packetSize)
  {
     //++++++++++++++++++++++++++++++++++++++++++++++++
     
     //считываем адресс и порт отправителя
     remote = Udp.remoteIP();

     //++++++++++++++++++++++++++++++++++++++++++++++++

     // читаем пакет в packetBufffer
     Udp.read(packetBuffer, UDP_TX_PACKET_MAX_SIZE);

     packetBuffer[packetSize] = '\x0';
     currStr = packetBuffer;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     if(currStr.startsWith("HEL")) //Если приведствие то устанавливаем флаг 
     {
       HellowProg = true;
       Time_Hallow_Prog = 0;
       SendUDPMessage("HEL");
     }
     else 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     //Чтение кадра управленяния реле пример 01*0218321843 02 канал 18.32 время включения 18.43 время выключения
     if(currStr.startsWith("01"))  
     {
       currStr = currStr.substring(3); //Убираем первых три символа (номер команды)
       
       byte Channel; 
       byte Chas_o; 
       byte Min_o;
        
       buf[0] = currStr.charAt(0); // читаем третий байт кадра и заносим его в буфер
       buf[1] = currStr.charAt(1); // читаем третий байт кадра и заносим его в буфер
       buf[2] = '\x0'; 
       Channel = atoi(buf); //Полученное в буфере число переводим в тип int  (номер канала)
        
       buf[0] = currStr.charAt(2); // читаем третий байт кадра и заносим его в буфер
       buf[1] = currStr.charAt(3); // читаем третий байт кадра и заносим его в буфер
       buf[2] = '\x0'; 
       Chas = atoi(buf); //Полученное в буфере число переводим в тип int (часов включения)
        
       buf[0] = currStr.charAt(4); // читаем третий байт кадра и заносим его в буфер
       buf[1] = currStr.charAt(5); // читаем третий байт кадра и заносим его в буфер
       buf[2] = '\x0'; 
       Min = atoi(buf); //Полученное в буфере число переводим в тип int (минут включения)
        
       buf[0] = currStr.charAt(6); // читаем третий байт кадра и заносим его в буфер
       buf[1] = currStr.charAt(7); // читаем третий байт кадра и заносим его в буфер
       buf[2] = '\x0'; 
       Chas_o = atoi(buf); //Полученное в буфере число переводим в тип int (часов выключения)
        
       buf[0] = currStr.charAt(8); // читаем третий байт кадра и заносим его в буфер
       buf[1] = currStr.charAt(9); // читаем третий байт кадра и заносим его в буфер
       buf[2] = '\x0'; 
       Min_o = atoi(buf); //Полученное в буфере число переводим в тип int (минут выключения)

       lcd.clear();
       lcd.setCursor(1, 0);
       lcd.print("WRITE CHENNAL");
       lcd.setCursor(2, 1);lcd.print("PLEASE WAIT");
       setTimeTad(Channel, Chas, Min, Chas_o, Min_o); //Отправляем данные для занесения в таблицу хронящуюся в EEPROM
       lcd.clear();
       SendUDPMessage("Ok");
     }
     else
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Чтение кадра установки тимператур пример 02*2123 21 температура мин кагда выключаем охлаждение 23 темп макс включаем охлаждения
    if(currStr.startsWith("02"))   
    {
       currStr = currStr.substring(3); //Убираем первых три символа (номер команды)

       buf[0] = currStr.charAt(0);
       buf[1] = currStr.charAt(1);
       buf[2] = '\x0';
       TemperaturaMin = atoi(buf); //Полученное в буфере число переводим в тип int (минимальная температура выключения охлаждения)
         
       buf[0] = currStr.charAt(2);
       buf[1] = currStr.charAt(3);
       buf[2] = '\x0';
       TemperaturaMax = atoi(buf); //Полученное в буфере число переводим в тип int (максимальная температура включения охлаждения)
 
       EEPROM.write(2881, TemperaturaMin); //Заносим в EEPROM
       EEPROM.write(2882, TemperaturaMax); //Заносим в EEPROM

       TemperaturaSred = (TemperaturaMin+TemperaturaMax)/2.0; //Расчет средней температуры

       SendUDPMessage("Ok");
    }
    else
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Чтение кадра полной очистки памяти 03*
    if(currStr.startsWith("03"))   
    {
       lcd.clear();
       lcd.setCursor(2, 0);
       lcd.print("EEPROM CLEAR");
       lcd.setCursor(2, 1);lcd.print("PLEASE WAIT");
       for(int i=0;i<4000;i++) EEPROM.write(i, 0);   //юбнуляем EEPROM
       lcd.clear();
       SendUDPMessage("Ok");
    }
    else
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Чтение кадра управленяния ШИМ LED пример 04*00001112225 0000 задерка 111 минимум 222 максимум 5вариант подсветки если 0 то автомат
    if(currStr.startsWith("04"))   
    {
       byte Temp_ml, Temp_st; 
       byte Min; 
       byte Max; 

       currStr = currStr.substring(3); //Убираем первых три символа (номер команды)
        
       buf[0] = currStr.charAt(0); // читаем третий байт кадра и заносим его в буфер
       buf[1] = currStr.charAt(1); // читаем четвертый байт кадра и заносим его в буфер
       buf[2] = currStr.charAt(2); //....
       buf[3] = currStr.charAt(3); //....
       buf[4] = '\x0';
       TimeLED = atoi(buf); //Полученное в буфере число переводим в тип int  (длительность)
        
       buf[0] = currStr.charAt(4);
       buf[1] = currStr.charAt(5);
       buf[2] = currStr.charAt(6); 
       buf[3] = '\x0';
       LED_MIN = atoi(buf); //Полученное в буфере число переводим в тип int (LED_MIN)
        
       buf[0] = currStr.charAt(7);
       buf[1] = currStr.charAt(8);
       buf[2] = currStr.charAt(9); 
       buf[3] = '\x0';
       LED_MAX = atoi(buf); //Полученное в буфере число переводим в тип int (LED_MAX)

       buf[0] = currStr.charAt(10);
       buf[1] = '\x0';
       LED = atoi(buf);  //вариант подсветки

       buf[0] = currStr.charAt(11);
       buf[1] = currStr.charAt(12);
       buf[2] = currStr.charAt(13); 
       buf[3] = '\x0';
       K = atoi(buf);

       Temp_ml = TimeLED & 0x00FF;
       Temp_st = (TimeLED >> 8) & 0x00FF; 
        
       EEPROM.write(2885, LED);
       EEPROM.write(2909, Temp_ml);
       EEPROM.write(2910, Temp_st);
       EEPROM.write(2911, LED_MIN);
       EEPROM.write(2912, LED_MAX);
       EEPROM.write(2913, K);
       Start_LED1 = true;
       Start_LED2 = true;
       Start_LED3 = true;
       Start_LED4 = true;
       Start_LED5 = true;
       SendUDPMessage("Ok");
    }
    else
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Чтение кадра очистки канала пример 05*11 стереть 11 канал
    if(currStr.startsWith("05"))   
    {
       currStr = currStr.substring(3); //Убираем первых три символа (номер команды)

       buf[0] = currStr.charAt(0);
       buf[1] = currStr.charAt(1);
       buf[2] = '\x0';
  
       lcd.clear();
       lcd.setCursor(1, 0);
       lcd.print("CLEAR CHENNAL");
       lcd.setCursor(2, 1);lcd.print("PLEASE WAIT");
       clearTimeChannel(atoi(buf)); //Очищаем полученный канал
       lcd.clear();  
       HellowProg = true;  
       SendUDPMessage("Ok");
    }
    else
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Чтение кадра установки времени и даты пример 06*0102201412346 01.02.2014 12:34 субота (1-понед.,2-вторник,...7-воскресение)
    if(currStr.startsWith("06"))   
    {
       currStr = currStr.substring(3); //Убираем первых три символа (номер команды)

       buf[0] = currStr.charAt(0);
       buf[1] = currStr.charAt(1);
       buf[2] = '\x0';
//       tm.Day = atoi(buf); //Полученное в буфере число переводим в тип int (день)
         
       buf[0] = currStr.charAt(2);
       buf[1] = currStr.charAt(3);
       buf[2] = '\x0';
//       tm.Month = atoi(buf); //Полученное в буфере число переводим в тип int (месяц)
        
       buf[0] = currStr.charAt(4);
       buf[1] = currStr.charAt(5);
       buf[2] = currStr.charAt(6);
       buf[3] = currStr.charAt(7);
       buf[4] = '\x0';
//       tm.Year   = CalendarYrToTm(atoi(buf)); //Полученное в буфере число переводим в тип int (год)
           
       buf[0] = currStr.charAt(8);
       buf[1] = currStr.charAt(9);
       buf[2] = '\x0';
//       tm.Hour = atoi(buf); //Полученное в буфере число переводим в тип int (час)
         
       buf[0] = currStr.charAt(10);
       buf[1] = currStr.charAt(11);
       buf[2] = '\x0';
//       tm.Minute = atoi(buf); //Полученное в буфере число переводим в тип int (мин)

//       tm.Second = 00;  
        
       buf[0] = currStr.charAt(12);
       buf[1] = '\x0';
//       tm.Wday = atoi(buf); //Полученное в буфере число переводим в тип int (мин)
                
//       RTC.write(tm);   //Заноси дату и время в RTC
       SendUDPMessage("Ok");
    }
    else
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Чтение кадра отправки всей памяти 07*
    if(currStr.startsWith("07"))   
    {
       lcd.clear();
       lcd.setCursor(2, 0);
       lcd.print("EEPROM READ");
       lcd.setCursor(2, 1);
       lcd.print("PLEASE WAIT");
       
       for(int q = 0; q < 2914; q++) 
       {
          buf[0] = char(EEPROM.read(q));
          buf[1] = '\x0';
          HellowProg = true;
          SendUDPMessage(buf);
       }

       HellowProg = true;
       SendUDPMessage("Ok");
       lcd.clear();
    }
    else
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Чтение кадра приема всей памяти 08*
    if(currStr.startsWith("08"))   
    {
      byte B;
      lcd.clear();
      lcd.setCursor(2, 0);
      lcd.print("EEPROM WRITE");
      lcd.setCursor(2, 1);
      lcd.print("PLEASE WAIT");
      //Serial.read();
      //for(int q=0;q<2914;q++)  
      //{
     //   if(Serial.available()) 
     //   {
     //     B = Serial.read(); 
     //     EEPROM.write( q, B);
     //   } else q--;  
    //  }
      lcd.clear();
      //Определяем и отображаем следующее событие
//      SetMessage((tm.Hour*60)+tm.Minute); 
       SendUDPMessage("Ok");
    }
    else
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Чтение кадра установок автоподмены 09*110215020 где 1 - день недели (1-пн. 2-вт. 3-ср. ... 7-вс.) 1-установить(0-выключить) включить в 02ч 15м на 20мин
    if(currStr.startsWith("09"))   
    {
       byte DN; 
       int Dlit;
       byte OK=0; 
       currStr = currStr.substring(3); //Убираем первых три символа (номер команды)
        
       buf[0] = currStr.charAt(0); // читаем третий байт кадра и заносим его в буфер
       buf[1] = '\x0';
       DN = atoi(buf); //Полученное в буфере число переводим в тип int  (день недели)
        
       buf[0] = currStr.charAt(1); // читаем третий байт кадра и заносим его в буфер
       buf[1] = '\x0';
       OK = atoi(buf); //Полученное в буфере число переводим в тип int  (Вкл./Выкл.)
  
       buf[0] = currStr.charAt(2);
       buf[1] = currStr.charAt(3);
       buf[2] = '\x0';
       Chas = atoi(buf); //Полученное в буфере число переводим в тип int (часов включения)
        
       buf[0] = currStr.charAt(4);
       buf[1] = currStr.charAt(5);
       buf[2] = '\x0';
       Min = atoi(buf); //Полученное в буфере число переводим в тип int (минут включения)
        
       buf[0] = currStr.charAt(6);
       buf[1] = currStr.charAt(7);
       buf[2] = currStr.charAt(8);
       buf[3] = '\x0';
       Dlit = atoi(buf); //Полученное в буфере число переводим в тип int (количество литров)
        
       lcd.clear();
       lcd.setCursor(1, 0);
       lcd.print("              ");
       lcd.setCursor(2, 1);lcd.print("PLEASE WAIT");
       if(OK) setAutoChangeWater(DN, Chas, Min, Dlit, true); //Отправляем данные для занесения в таблицу хронящуюся в EEPROM
       else   setAutoChangeWater(DN, Chas, Min, Dlit, false);
       lcd.clear();
       SendUDPMessage("Ok");
    }
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //       SendUDPMessage("Resiv 1");
   } //  if (packetSize)
}

//============================================================================================================

